<?php
/*
 AUF plugin for GLPI
 Copyright (C) 2014 AUF -- www.auf.org
 */
if (!defined('GLPI_ROOT')) {
   die("Sorry. You can't access directly to this file");
}

class PluginAufProfile extends CommonDBTM {

   static function canCreate() {
      if (isset($_SESSION["glpi_plugin_auf_profile"])) {
         return ($_SESSION["glpi_plugin_auf_profile"]['auf'] == 'w');
      }
      return false;
   }

   static function canView() {
      if (isset($_SESSION["glpi_plugin_auf_profile"])) {
         return ($_SESSION["glpi_plugin_auf_profile"]['auf'] == 'w'
                 || $_SESSION["glpi_plugin_auf_profile"]['auf'] == 'r');
      }
      return false;
   }

   static function createAdminAccess($ID) {
      $myProf = new self();
      // si le profile n'existent pas déjà dans la table profile de mon plugin
      if (!$myProf->getFromDB($ID)) {
         // ajouter un champ dans la table comprenant l'ID du profil de la
         // personne connectée et le droit d'écriture
         $myProf->add(array('id' => $ID, 'right' => 'w'));
      }
   }

   function createAccess($ID) {
      $this->add(array('id' => $ID));
   }

   static function changeProfile() {
      $prof = new self();
      if ($prof->getFromDB($_SESSION['glpiactiveprofile']['id'])) {
         $_SESSION["glpi_plugin_auf_profile"] = $prof->fields;
      } else {
         unset($_SESSION["glpi_plugin_auf_profile"]);
      }
   }

   function showForm($id, $options=array()) {
      $target = $this->getFormURL();
      if (isset($options['target'])) {
        $target = $options['target'];
      }

      if (!Session::haveRight("profile", "r")) {
         return false;
      }

      $canedit = Session::haveRight("profile", "w");
      $prof = new Profile();
      if ($id){
         $this->getFromDB($id);
         $prof->getFromDB($id);
      }

      echo "<form action='".$target."' method='post'>";
      echo "<table class='tab_cadre_fixe'>";
      echo "<tr><th colspan='2' class='center b'>".sprintf(__('%1$s %2$s'),
         ('Gestion des droits -'), Dropdown::getDropdownName("glpi_profiles",
         $this->fields["id"]));
      echo "</th></tr>";

      echo "<tr class='tab_bg_2'>";
      echo "<td>Infos AUF</td><td>";
      Profile::dropdownNoneReadWrite("right", $this->fields["right"], 1, 1, 1);
      echo "</td></tr>";

      if ($canedit) {
         echo "<tr class='tab_bg_1'>";
         echo "<td class='center' colspan='2'>";
         echo "<input type='hidden' name='id' value=$id>";
         echo "<input type='submit' name='update_user_profile' value='Mettre à jour' class='submit'>";
         echo "</td></tr>";
      }
      echo "</table>";
      Html::closeForm();
   }

   function getTabNameForItem(CommonGLPI $item, $withtemplate=0) {
      if ($item->getType() == 'Profile') {
         return "Infos AUF";
      }
      return '';
   }

   static function displayTabContentForItem(CommonGLPI $item, $tabnum=1, $withtemplate=0) {
      if ($item->getType() == 'Profile') {
         $ID = $item->getID();
         $prof = new self();
         // si le profil n'existe pas dans la base, je l'ajoute
         if (!$prof->GetfromDB($ID)) {
            $prof->createAccess($ID);
         }
         $prof->showForm($ID);
      }
      return true;
   }

}

?>
